
#include <errno.h>

#include <moep/types.h>
#include <moep/ieee80211_addr.h>

#include "list.h"
#include "timeout.h"


struct neighbor {
	struct list_head list;
	u8 hwaddr[IEEE80211_ALEN];
	u16 lseq;
	timeout_t timeout;
};


LIST_HEAD(nl); // neighbor list


/*
 * Callback for timeout setup in Problem 1b). The function is not called
 * is called automatically when the timeout expires. The argument data points
 * to the neighbor in question. The other two arguments are unused.
 */
static int cb_delete(timeout_t t, u32 overrun, void *data)
{
	(void) overrun;
	(void) t;
	return 0;
}

/*
 * Iterate over the neighbor list nb and find the neighbor using the supplied
 * hwaddr. If the neighbor is found, return a pointer to it, and NULL
 * otherwise.
 */
static struct neighbor *find(const u8 *hwaddr)
{
	return NULL;
}

/*
 * Create a new neighbor from the given hwaddr. Return 0 on success and -1
 * with errno set appropriately otherwise, e.g. EEXIST if the neighbor in
 * question already exists.
 */
int nb_add(const u8 *hwaddr)
{
	errno = ENOTSUP;
	return -1;
}

/*
 * Delete a neighbor given its hwaddr. Return 0 on success and -1 otherwise
 * with errno set appropriately.
 */
int nb_del(const u8 *hwaddr)
{
	errno = ENOTSUP;
	return -1;
}

/*
 * Called whenever a frame is received. hwaddr is the transmitter (neighbor
 * address), seq is the sequence number of the frame.
 * Find the neighbor given hwaddr or create a new neighbor if neccessary.
 * Set / update the neighbor's lseq (last sequence number).
 * In Problem 1b) add also update the neighbor's timeout. In Problem 2)
 * additional code for updating link qualities may be added.
 */
int nb_update_seq(const u8 *hwaddr, u16 seq)
{
	errno = ENOTSUP;
	return -1;
}
